pragma solidity 0.8.19;

import "@interfaces/ISablier.sol";
import "@interfaces/IERC20.sol";

contract Proposal {
    function executeProposal() external {
        uint256 FISCAL_QUARTER_DURATION = 91 days;
        uint256 REMUNERATION_START_TS = block.timestamp;
        uint256 REMUNERATION_AMOUNT = 4172 ether;
        uint256 REMUNERATION_NORMALISED_AMOUNT = REMUNERATION_AMOUNT -
            (REMUNERATION_AMOUNT % FISCAL_QUARTER_DURATION);

        uint256 SERVICES_COST_REIMBURSEMENT_AMOUNT = 834 ether;

        address _tokenAddress = 0x77777FeDdddFfC19Ff86DB637967013e6C6A116C;
        address _sablierAddress = 0xCD18eAa163733Da39c232722cBC4E8940b1D8888;
        address REMUNERATION_ADDRESS = 0x9Ff3C1Bea9ffB56a78824FE29f457F066257DD58;

        IERC20(_tokenAddress).transfer(
            REMUNERATION_ADDRESS,
            SERVICES_COST_REIMBURSEMENT_AMOUNT
        );

        IERC20(_tokenAddress).approve(
            _sablierAddress,
            REMUNERATION_NORMALISED_AMOUNT
        );

        ISablier(_sablierAddress).createStream(
            REMUNERATION_ADDRESS,
            REMUNERATION_NORMALISED_AMOUNT,
            _tokenAddress,
            REMUNERATION_START_TS,
            REMUNERATION_START_TS + FISCAL_QUARTER_DURATION
        );
    }
}
